#include <iostream>
#include <vector>

void merge_sort(std::vector<int> &a, int l, int r, int &inversions)
{
    if (l >= r)
        return ;

    static std::vector<int> b(a.size());

    int m = (l + r) / 2;

    merge_sort(a, l, m, inversions);
    merge_sort(a, m + 1, r, inversions);

    int i = l, j = m + 1, k = 0;

    while (i <= m && j <= r) {
        if (a[i] <= a[j]) {
            b[k] = a[i];
            i++;
        }
        else {
            b[k] = a[j];
            j++;
            inversions += m - i + 1;
        }
        k++;
    }

    while (i <= m) {
        b[k] = a[i];
        k++;
        i++;
    }

    while (j <= r) {
        b[k] = a[j];
        k++;
        j++;
    }

    i = l, k = 0;
    while (i <= r) {
        a[i] = b[k];
        i++;
        k++;
    }
}

int main ()
{
    std::vector<int> a = {8, 4, 2, 1};

    int inversions = 0;

    merge_sort(a, 0, a.size() - 1, inversions);

    for (int x : a)
        std::cout << x << " ";
    std::cout << "\n";

    std::cout << inversions << std::endl;
 
    return 0;
}
