#include <iostream>
#include <vector>
#include <algorithm>

int max_zbir(const std::vector<int> &a, int l, int d) 
{
    if(l > d)
        return 0;

    int s = (l + d) / 2;
    int max_levo = max_zbir(a, l, s - 1);
    int max_desno = max_zbir(a, s + 1, d);
    int sredina = a[s];
    
    int max_sredina = sredina;
    
    for(int i = s - 1; i >= l; i--) {
        sredina += a[i];
        if(sredina > max_sredina)
            max_sredina = sredina;
    }
    
    sredina = max_sredina;
    for(int i = s + 1; i <= d; i++) {
        sredina += a[i];
        if(sredina > max_sredina)
            max_sredina = sredina;
    }

    return std::max({max_levo, max_desno, max_sredina});
}

void max_zbir_v2(const std::vector<int> &a, int l, int d, int &zbir, int &max_zbir, int &max_prefiks, int &max_sufiks) 
{
    if(l == d) {
        zbir = a[l];
        max_zbir = a[l];
        max_prefiks = a[l];
        max_sufiks = a[l];
        return;
    }
    
    int s = (l + d) / 2;
    int zbir_levo, max_zbir_levo, max_sufiks_levo, max_prefiks_levo;
    int zbir_desno, max_zbir_desno, max_sufiks_desno, max_prefiks_desno;

    max_zbir_v2(a, l, s, zbir_levo, max_zbir_levo, max_prefiks_levo, max_sufiks_levo);
    max_zbir_v2(a, s+1, d, zbir_desno, max_zbir_desno, max_prefiks_desno, max_sufiks_desno);
    
    zbir = zbir_levo + zbir_desno;
    
    max_prefiks = std::max(max_prefiks_levo, zbir_levo + max_prefiks_desno);
    max_sufiks = std::max(max_sufiks_desno, max_sufiks_levo + zbir_desno);
    
    max_zbir = std::max({max_zbir_levo, max_zbir_desno, max_sufiks_levo + max_prefiks_desno});
}

int main ()
{


    return 0;
}